/*
 * File         : hpjava_lang_BlockCyclicRange.C
 * Author       : Han-Ku Lee
 * Created      : Mon Dec 6 12:06:49 1997
 * Revision     : $Revision: 1.1 $
 * Copyright    : Northeast Parallel Architectures Center
 *                at Syracuse University 1997
 */

#include "hpjava_lang_BlockCyclicRange.h"
#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;

/*
 * Class:     hpjava_lang_BlockCyclicRange
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockCyclicRange_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_lang_BlockCyclicRange
 * Method:    constructor
 * Signature: (ILhpjava/lang/Range;I)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockCyclicRange_constructor
  (JNIEnv* env, jobject jthis, jint extent, jobject ker, jint blockSize)
{
  BlockCyclicRange *cppBlockCyclicRange = new BlockCyclicRange(extent, ((Range*)(env->GetLongField(ker, hCPPObjID)))->dim(), blockSize);

  delete (Range*)env->GetLongField(jthis, hCPPObjID);

  if (cppBlockCyclicRange == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppBlockCyclicRange);
}

/*
 * Class:     hpjava_lang_BlockCyclicRange
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockCyclicRange_finalize
  (JNIEnv* env, jobject jthis)
{
  delete (BlockCyclicRange*)env->GetLongField(jthis, hCPPObjID);
}

/*
 * Class:     hpjava_lang_BlockCyclicRange
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockCyclicRange_init
  (JNIEnv * env, jclass jthis)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");
}
