/*
 * File         : hpjava_lang_BlockRange.C
 * Author       : Guansong Zhang, Han-Ku Lee
 * Created      : Mon Oct 13 12:06:49 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/12/07 18:46:17 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "hpjava_lang_BlockRange.h"
#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");
};

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    constructor
 * Signature: (ILhpjava/lang/Range;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_constructor
  (JNIEnv * env, jobject jthis, jint extent, jobject ker)
{
  BlockRange *cppBlockRange = new BlockRange(extent, ((Range*)(env->GetLongField(ker, hCPPObjID)))->dim());

  //long pos = env->GetLongField(jthis, hCPPObjID);

  //delete (hpjava_lang_Range_Table.ObjPtr[pos]);
  delete (Range*)env->GetLongField(jthis, hCPPObjID);

  //hpjava_lang_Range_Table.ObjPtr[pos]=cppBlockRange;
 
  if (cppBlockRange == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppBlockRange);
};

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_finalize
  (JNIEnv * env, jobject jthis)
{
  delete (BlockRange*)env->GetLongField(jthis, hCPPObjID);
}
