/*
 * File         : hpjava_lang_Dimension.C
 * Author       : Guansong Zhang, Han-Ku Lee
 * Created      : Mon Oct 13 12:03:03 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/12/07 18:46:20 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "hpjava_lang_Dimension.h"
#include "adlib.h"
#include "apgStack.h"

extern jfieldID hCPPObjID;

//#include "jctable.h"
//jctable<Dimension> hpjava_lang_Dimension_Table;

/*ResolvePtr
 */
//Dimension * hpjava_lang_Dimension_ResolvePtr(JNIEnv *env, jobject jthis) {
//  return(hpjava_lang_Dimension_Table.ObjPtr[env->GetLongField(jthis, hCPPObjID)]);
//}

/*
 * Class:     hpjava_lang_Dimension
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Dimension_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");
  //jctable<Dimension> *temphpjava_lang_Dimension_Table=new jctable<Dimension>;
  //hpjava_lang_Dimension_Table=*temphpjava_lang_Dimension_Table;
};

/*
 * Class:     hpjava_lang_Dimension
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Dimension_clean
  (JNIEnv *, jclass)
{
//  delete hpjava_lang_Dimension_ObjPtr;
//  delete hpjava_lang_Dimension_ObjRef;
};

/*
 * Class:     hpjava_lang_Dimension
 * Method:    constructor
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Dimension_constructor
  (JNIEnv * env, jobject jthis)
{
  //Dimension *cppDim = new Dimension();

  DimRange* cppDimRange = new DimRange(*(Dimension*)jthis);

  //long pos = hpjava_lang_Dimension_Table.NewHandle(cppDim);

  if (cppDimRange == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppDimRange);
};

/*
 * Class:     hpjava_lang_Dimension
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Dimension_finalize
  (JNIEnv * env, jobject jthis)
{
  //long thecppobj=env->GetLongField(jthis, hCPPObjID);
  //long rc=hpjava_lang_Dimension_Table.DecRefCntr(thecppobj);
  //if (rc==0) {
  //  delete hpjava_lang_Dimension_Table.ObjPtr[thecppobj];
  //  hpjava_lang_Dimension_Table.ObjPtr[thecppobj]=NULL;
  //}

  //delete (Dimension*)env->GetLongField(jthis, hCPPObjID);
  delete (DimRange*)env->GetLongField(jthis, hCPPObjID);
};


/*
 * Class:     hpjava_lang_Dimension
 * Method:    crd
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Dimension_crd
  (JNIEnv * env, jobject jthis)
{
  //int temp = hpjava_lang_Dimension_ResolvePtr(env, jthis)->crd();
  //int temp = ((Dimension*)env->GetLongField(jthis, hCPPObjID))->crd();
  int temp = (((DimRange*)env->GetLongField(jthis, hCPPObjID))->dim()).crd();

  //printf("in crd dim address %x\n", hpjava_lang_Dimension_ResolvePtr(env, jthis));
  //printf("crd is %d\n", temp);
  return(temp);
};
