/*
 * File         : hpjava_lang_ExtBlockRange.C
 * Author       : Han-Ku Lee
 * Created      : Mon Dec 6 12:06:49 1999
 * Revision     : $Revision: 1.1 $
 * Copyright    : Northeast Parallel Architectures Center
 *                at Syracuse University 1997
 */

#include "hpjava_lang_ExtBlockRange.h"
#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;

/*
 * Class:     hpjava_lang_ExtBlockRange
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_ExtBlockRange_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_lang_ExtBlockRange
 * Method:    constructor
 * Signature: (ILhpjava/lang/Range;II)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_ExtBlockRange_constructor
  (JNIEnv * env, jobject jthis, jint extent, jobject ker, jint wlo, jint whi)
{
  BlockRange *cppExtBlockRange = new BlockRange(extent, ((Range*)(env->GetLongField(ker, hCPPObjID)))->dim(), wlo, whi);

  delete (Range*)env->GetLongField(jthis, hCPPObjID);

  if (cppExtBlockRange == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppExtBlockRange);
}

/*
 * Class:     hpjava_lang_ExtBlockRange
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_ExtBlockRange_finalize
  (JNIEnv * env, jobject jthis)
{
  delete (BlockRange*)env->GetLongField(jthis, hCPPObjID);
}

/*
 * Class:     hpjava_lang_ExtBlockRange
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_ExtBlockRange_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");
}
