/*
 * File         : hpjava_lang_IrregRange.C
 * Author       : Han-Ku Lee
 * Created      : Mon Dec 6 12:06:49 1997
 * Revision     : $Revision: 1.2 $
 * Copyright    : Northeast Parallel Architectures Center
 *                at Syracuse University 1997
 */

#include "hpjava_lang_IrregRange.h"
#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;

/*
 * Class:     hpjava_lang_IrregRange
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_IrregRange_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_lang_IrregRange
 * Method:    constructor
 * Signature: (Lhpjava/lang/Range;[I)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_IrregRange_constructor
  (JNIEnv* env, jobject jthis, jobject ker, jintArray blocks)
{
  jboolean isCopy;
  jint* cblocks = env->GetIntArrayElements(blocks, &isCopy);

  IrregRange *cppIrregRange = new IrregRange(((Range*)(env->GetLongField(ker, hCPPObjID)))->dim(), cblocks);

  delete (Range*)env->GetLongField(jthis, hCPPObjID);

  if (cppIrregRange == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppIrregRange);

  if(isCopy == JNI_TRUE){
    env->ReleaseIntArrayElements(blocks, cblocks, 0);
  }
}

/*
 * Class:     hpjava_lang_IrregRange
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_IrregRange_finalize
  (JNIEnv* env, jobject jthis)
{
  delete (IrregRange*)env->GetLongField(jthis, hCPPObjID);
}

/*
 * Class:     hpjava_lang_IrregRange
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_IrregRange_init
  (JNIEnv * env, jclass jthis)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");
}

