/*
 * File         : Maxval.C
 * Author       : Han-Ku Lee
 * Created      : Sat Oct 30 18:16:43 1999
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/12/07 18:48:48 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1999
 */

#include "hpjava_spmd_adlib_Maxval.h"
#include "adlib.h"

//DAD * hpjava_lang_DAD_ResolvePtr(JNIEnv *, jobject);
extern jfieldID hCPPObjID;

/*
 * Class:     Maxval
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Maxval_init
(JNIEnv *env , jclass jthis)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");    
}

/*
 * Class:     Maxval
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Maxval_clean
(JNIEnv *, jclass);

/*
 * Class:     Maxval
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Maxval_finalize
(JNIEnv *env, jobject jthis)
{
  delete (Maxval<jdouble> *)env->GetLongField(jthis, hCPPObjID);
  delete (Maxval<jfloat> *)env->GetLongField(jthis, hCPPObjID);
  delete (Maxval<jint> *)env->GetLongField(jthis, hCPPObjID);
  delete (Maxval<jshort> *)env->GetLongField(jthis, hCPPObjID);
}

/*
 * Class:     hpjava_spmd_adlib_Maxval
 * Method:    double_constructor
 * Signature: (Lhpjava/lang/DAD;I)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Maxval_double_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Maxval<jdouble> *cppMaxval = new Maxval<jdouble>(sDADPtr);
	
  if (cppMaxval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMaxval);  
}

JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Maxval_float_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Maxval<jfloat> *cppMaxval = new Maxval<jfloat>(sDADPtr);

  if (cppMaxval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMaxval);  
}

JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Maxval_int_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Maxval<jint> *cppMaxval = new Maxval<jint>(sDADPtr);

  if (cppMaxval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMaxval);  
}



JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Maxval_short_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Maxval<jshort> *cppMaxval = new Maxval<jshort>(sDADPtr);

  if (cppMaxval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMaxval);  
}

/*
 * Class:     hpjava_spmd_adlib_Maxval
 * Method:    execute
 * Signature: ([B)B
 */

JNIEXPORT jdouble JNICALL Java_hpjava_spmd_adlib_Maxval_execute___3D
(JNIEnv *env, jobject jthis, jdoubleArray src)
{
  jint dLength = env->GetArrayLength(src);
  jdouble _max;
  jdouble *jSA = env->GetDoubleArrayElements(src, 0);

  ((Maxval<jdouble> *)env->GetLongField(jthis, hCPPObjID))->execute(&_max, jSA);

  env->ReleaseDoubleArrayElements(src, jSA, JNI_ABORT);

  return _max;
}

JNIEXPORT jfloat JNICALL Java_hpjava_spmd_adlib_Maxval_execute___3F
(JNIEnv *env, jobject jthis, jfloatArray src)
{
  jint dLength = env->GetArrayLength(src);
  jfloat _max;
  jfloat *jSA = env->GetFloatArrayElements(src, 0);

  ((Maxval<jfloat> *)env->GetLongField(jthis, hCPPObjID))->execute(&_max, jSA);

  env->ReleaseFloatArrayElements(src, jSA, JNI_ABORT);

  return _max;
}

JNIEXPORT jint JNICALL Java_hpjava_spmd_adlib_Maxval_execute___3I
(JNIEnv *env, jobject jthis, jintArray src)
{
  jint dLength = env->GetArrayLength(src);
  jint _max;
  jint *jSA = env->GetIntArrayElements(src, 0);

	((Maxval<jint> *)env->GetLongField(jthis, hCPPObjID))->execute(&_max, jSA);

  env->ReleaseIntArrayElements(src, jSA, JNI_ABORT);

  return _max;
}


JNIEXPORT jshort JNICALL Java_hpjava_spmd_adlib_Maxval_execute___3S
(JNIEnv *env, jobject jthis, jshortArray src)
{
  jint dLength = env->GetArrayLength(src);
  jshort _max;
  jshort *jSA = env->GetShortArrayElements(src, 0);

  ((Maxval<jshort> *)env->GetLongField(jthis, hCPPObjID))->execute(&_max, jSA);

  env->ReleaseShortArrayElements(src, jSA, JNI_ABORT);

  return _max;
}

