/*
 * File         : Minval.C
 * Author       : Han-Ku Lee
 * Created      : Sat Oct 30 18:16:43 1999
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/12/07 18:48:49 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1999
 */

#include "hpjava_spmd_adlib_Minval.h"
#include "adlib.h"

//DAD * hpjava_lang_DAD_ResolvePtr(JNIEnv *, jobject);
extern jfieldID hCPPObjID;

/*
 * Class:     Minval
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Minval_init
(JNIEnv *env , jclass jthis)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");    
}

/*
 * Class:     Minval
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Minval_clean
(JNIEnv *, jclass);

/*
 * Class:     Minval
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Minval_finalize
(JNIEnv *env, jobject jthis)
{
  delete (Minval<jdouble> *)env->GetLongField(jthis, hCPPObjID);
  delete (Minval<jfloat> *)env->GetLongField(jthis, hCPPObjID);
  delete (Minval<jint> *)env->GetLongField(jthis, hCPPObjID);
  delete (Minval<jshort> *)env->GetLongField(jthis, hCPPObjID);
}

/*
 * Class:     hpjava_spmd_adlib_Minval
 * Method:    double_constructor
 * Signature: (Lhpjava/lang/DAD;I)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Minval_double_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Minval<jdouble> *cppMinval = new Minval<jdouble>(sDADPtr);
	
  if (cppMinval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMinval);  
}

JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Minval_float_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Minval<jfloat> *cppMinval = new Minval<jfloat>(sDADPtr);

  if (cppMinval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMinval);  
}

JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Minval_int_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Minval<jint> *cppMinval = new Minval<jint>(sDADPtr);

  if (cppMinval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMinval);  
}



JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Minval_short_1constructor
(JNIEnv *env, jobject jthis, jobject sDAD, jint len)
{
  //DAD *sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD);
  DAD *sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID);;
  Minval<jshort> *cppMinval = new Minval<jshort>(sDADPtr);

  if (cppMinval == NULL) {
    jclass cError = env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError, "adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMinval);  
}

/*
 * Class:     hpjava_spmd_adlib_Minval
 * Method:    execute
 * Signature: ([B)B
 */

JNIEXPORT jdouble JNICALL Java_hpjava_spmd_adlib_Minval_execute___3D
(JNIEnv *env, jobject jthis, jdoubleArray src)
{
  jint dLength = env->GetArrayLength(src);
  jdouble _min;
  jdouble *jSA = env->GetDoubleArrayElements(src, 0);

  ((Minval<jdouble> *)env->GetLongField(jthis, hCPPObjID))->execute(&_min, jSA);

  env->ReleaseDoubleArrayElements(src, jSA, JNI_ABORT);

  return _min;
}

JNIEXPORT jfloat JNICALL Java_hpjava_spmd_adlib_Minval_execute___3F
(JNIEnv *env, jobject jthis, jfloatArray src)
{
  jint dLength = env->GetArrayLength(src);
  jfloat _min;
  jfloat *jSA = env->GetFloatArrayElements(src, 0);

  ((Minval<jfloat> *)env->GetLongField(jthis, hCPPObjID))->execute(&_min, jSA);

  env->ReleaseFloatArrayElements(src, jSA, JNI_ABORT);

  return _min;
}

JNIEXPORT jint JNICALL Java_hpjava_spmd_adlib_Minval_execute___3I
(JNIEnv *env, jobject jthis, jintArray src)
{
  jint dLength = env->GetArrayLength(src);
  jint _min;
  jint *jSA = env->GetIntArrayElements(src, 0);

	((Minval<jint> *)env->GetLongField(jthis, hCPPObjID))->execute(&_min, jSA);

  env->ReleaseIntArrayElements(src, jSA, JNI_ABORT);

  return _min;
}


JNIEXPORT jshort JNICALL Java_hpjava_spmd_adlib_Minval_execute___3S
(JNIEnv *env, jobject jthis, jshortArray src)
{
  jint dLength = env->GetArrayLength(src);
  jshort _min;
  jshort *jSA = env->GetShortArrayElements(src, 0);

  ((Minval<jshort> *)env->GetLongField(jthis, hCPPObjID))->execute(&_min, jSA);

  env->ReleaseShortArrayElements(src, jSA, JNI_ABORT);

  return _min;
}

