/*
 * File         : hpjava_spmd_adlib_Remap.C
 * Author       : Guansong Zhang
 * Created      : Mon Oct 27 16:31:17 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/12/07 19:03:08 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "hpjava_spmd_adlib_Remap.h"
#include "adlib.h"

//DAD * hpjava_lang_DAD_ResolvePtr(JNIEnv *, jobject);

extern jfieldID hCPPObjID;
//#include "jctable.h"
//jctable<Remap> hpjava_spmd_adlib_Remap_Table;

/*ResolvePtr
 */
//Remap * hpjava_spmd_adlib_Remap_ResolvePtr(JNIEnv *env, jobject jthis) {
//  return(hpjava_spmd_adlib_Remap_Table.ObjPtr[env->GetIntField(jthis, hCPPObjID)]);
//}

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_init
  (JNIEnv * env, jclass jthis)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");  
  //jctable<Remap> *temphpjava_spmd_adlib_Remap_Table=new jctable<Remap>;
  //hpjava_spmd_adlib_Remap_Table=*temphpjava_spmd_adlib_Remap_Table;
  //delete temphpjava_spmd_adlib_Remap_Table;
};

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    constructor
 * Signature: (Lhpjava/lang/DAD;Lhpjava/lang/DAD;I)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_constructor
  (JNIEnv *env, jobject jthis, jobject dDAD, jobject sDAD, jint len)
{
  //DAD * dDADPtr = hpjava_lang_DAD_ResolvePtr(env, dDAD); 
  DAD * dDADPtr = (DAD*)env->GetLongField(dDAD, hCPPObjID); 
  //DAD * sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD); 
  DAD * sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID); 

  Remap *cppRemap = new Remap(dDADPtr, sDADPtr, len);
  //long pos= hpjava_spmd_adlib_Remap_Table.NewHandle(cppRemap);

  if (cppRemap == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetIntField(jthis, hCPPObjID, (long)cppRemap);  
};

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_finalize
  (JNIEnv * env, jobject jthis) 
{
  //long thecppobj=env->GetIntField(jthis, hCPPObjID);
  //long rc=hpjava_spmd_adlib_Remap_Table.DecRefCntr(thecppobj);
  //if (rc==0) {
  //  delete hpjava_spmd_adlib_Remap_Table.ObjPtr[thecppobj];
  //  hpjava_spmd_adlib_Remap_Table.ObjPtr[thecppobj]=NULL;
  //}

  delete (Remap*)env->GetLongField(jthis, hCPPObjID);
};

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([IJ[IJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3IJ_3IJ
(JNIEnv * env, jobject jthis, jintArray dst, jlong dOffset, jintArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jint * jDA=env->GetIntArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jint * jSA=env->GetIntArrayElements(src, &isCopy);

  /*
  {//debug
    int i;

    for (i=0; i<dLength; i++) {
      printf("dst %d: %d | ", i, *(jDA+i));
    }
    printf("\n");
    
    for (i=0; i<sLength; i++) {
      printf("src %d: %d | ", i, *(jSA+i));
    }
    printf("\n");
  }
  */

  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  //printf("recorded remap at %x; dOffset %d; sOffset %d\n", hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis), dOffset, sOffset);  //debug

  /*
  {//debug
    int i;

    for (i=0; i<dLength; i++) {
      printf("dst- %d: %d | ", i, *(jDA+i));
    }
    printf("\n");
    
    for (i=0; i<sLength; i++) {
      printf("src- %d: %d | ", i, *(jSA+i));
    }
    printf("\n");
  }
  */

  env->ReleaseIntArrayElements(dst, jDA, 0);
  env->ReleaseIntArrayElements(src, jSA, JNI_ABORT);
};

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([FJ[FJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3FJ_3FJ
(JNIEnv * env, jobject jthis, jfloatArray dst, jlong dOffset, jfloatArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jfloat * jDA=env->GetFloatArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jfloat * jSA=env->GetFloatArrayElements(src, &isCopy);

  /*  {//debug
    int i;

    AdlibPrintf("dst ");
    for (i=0; i<dLength; i++) {
      printf("%d: %f | ", i, *(jDA+i));
    }
    printf("\n");

    AdlibPrintf("src ");
    for (i=0; i<sLength; i++) {
      printf("%d: %f | ", i, *(jSA+i));
    }
    printf("\n");
  }
  
  */
  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  /*{//debug
    int i;

    AdlibPrintf("dst- ");
    for (i=0; i<dLength; i++) {
      printf(" %d: %f | ", i, *(jDA+i));
    }
    printf("\n");

    AdlibPrintf("src- ");
    for (i=0; i<sLength; i++) {
      printf("%d: %f | ", i, *(jSA+i));
    }
    printf("\n");
  }
  */

  env->ReleaseFloatArrayElements(dst, jDA, 0);
  env->ReleaseFloatArrayElements(src, jSA, JNI_ABORT);
};

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([BJ[BJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3BJ_3BJ
(JNIEnv *env, jobject jthis, jbyteArray dst, jlong dOffset, jbyteArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jbyte * jDA=env->GetByteArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jbyte * jSA=env->GetByteArrayElements(src, &isCopy);

  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  env->ReleaseByteArrayElements(dst, jDA, 0);
  env->ReleaseByteArrayElements(src, jSA, JNI_ABORT);
}

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([CJ[CJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3CJ_3CJ
(JNIEnv *env, jobject jthis, jcharArray dst, jlong dOffset, jcharArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jchar * jDA=env->GetCharArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jchar * jSA=env->GetCharArrayElements(src, &isCopy);

  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  env->ReleaseCharArrayElements(dst, jDA, 0);
  env->ReleaseCharArrayElements(src, jSA, JNI_ABORT);
}

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([DJ[DJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3DJ_3DJ
(JNIEnv *env, jobject jthis, jdoubleArray dst, jlong dOffset, jdoubleArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jdouble * jDA=env->GetDoubleArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jdouble * jSA=env->GetDoubleArrayElements(src, &isCopy);

  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  env->ReleaseDoubleArrayElements(dst, jDA, 0);
  env->ReleaseDoubleArrayElements(src, jSA, JNI_ABORT);
}

/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([JJ[JJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3JJ_3JJ
(JNIEnv *env, jobject jthis, jlongArray dst, jlong dOffset, jlongArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jlong * jDA=env->GetLongArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jlong * jSA=env->GetLongArrayElements(src, &isCopy);

  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  env->ReleaseLongArrayElements(dst, jDA, 0);
  env->ReleaseLongArrayElements(src, jSA, JNI_ABORT);
}


/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([SJ[SJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3SJ_3SJ
(JNIEnv *env, jobject jthis, jshortArray dst, jlong dOffset, jshortArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jshort * jDA=env->GetShortArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jshort * jSA=env->GetShortArrayElements(src, &isCopy);

  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  env->ReleaseShortArrayElements(dst, jDA, 0);
  env->ReleaseShortArrayElements(src, jSA, JNI_ABORT);
}


/*
 * Class:     hpjava_spmd_adlib_Remap
 * Method:    execute
 * Signature: ([ZJ[ZJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_Remap_execute___3ZJ_3ZJ
(JNIEnv *env, jobject jthis, jbooleanArray dst, jlong dOffset, jbooleanArray src, jlong sOffset)
{
  jboolean isCopy;

  int dLength=env->GetArrayLength(dst);
  jboolean * jDA=env->GetBooleanArrayElements(dst, &isCopy);
    
  int sLength=env->GetArrayLength(src);
  jboolean * jSA=env->GetBooleanArrayElements(src, &isCopy);

  //hpjava_spmd_adlib_Remap_ResolvePtr(env, jthis)->execute(jDA+dOffset, jSA+sOffset); 
  ((Remap*)env->GetLongField(jthis, hCPPObjID))->execute(jDA+dOffset, jSA+sOffset); 

  env->ReleaseBooleanArrayElements(dst, jDA, 0);
  env->ReleaseBooleanArrayElements(src, jSA, JNI_ABORT);
}

