/*
 * File         : hpjava_lang_Stride.C
 * Author       : Guansong Zhang, Han-Ku Lee
 * Created      : Mon Oct 13 12:06:49 1997
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1999/12/16 03:39:21 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "hpjava_lang_Stride.h"
#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;

jfieldID offsetID=0;
jfieldID stepID=0;
//jfieldID lenID=0;

//Location * hpjava_lang_Location_ResolvePtr(JNIEnv *, jobject);
//LocBlocksIndex * hpjava_lang_LocBlocksIndex_ResolvePtr(JNIEnv *, jobject);

/*
 * Class:     hpjava_lang_Stride
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "J");

  jclass Map_class=env->FindClass("hpjava/lang/Stride");
  offsetID=env->GetFieldID(Map_class, "offset", "I");
  stepID=env->GetFieldID(Map_class, "step", "I");
  //lenID=env->GetFieldID(Map_class, "len", "I");
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_lang_Stride
 * Method:    constructor
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_constructor__
  (JNIEnv *env, jobject jthis)
{
  Map *cppMap = new Map();

  if (cppMap == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMap);
}

/*
 * Class:     hpjava_lang_Stride
 * Method:    constructor
 * Signature: (Lhpjava/lang/Range;I)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_constructor__Lhpjava_lang_Range_2I
(JNIEnv *env, jobject jthis, jobject jRange, jint stride)
{
 
  Map *cppMap = new Map(*(Range*)env->GetLongField(jRange, hCPPObjID), stride);

  if (cppMap == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppMap);
}

/*
 * Class:     hpjava_lang_Stride
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_finalize
  (JNIEnv * env, jobject jthis)
{
  //long thecppobj=env->GetLongField(jthis, hCPPObjID);
  //long rc=hpjava_lang_Stride_Table.DecRefCntr(thecppobj);
  //if (rc==0) {
  //  delete hpjava_lang_Stride_Table.ObjPtr[thecppobj];
  //  hpjava_lang_Stride_Table.ObjPtr[thecppobj]=NULL;
  //}

  delete (Range*)env->GetLongField(jthis, hCPPObjID);
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    disp
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_disp
  (JNIEnv * env, jobject jthis, jint sub)
{
  return ((Map *)env->GetLongField(jthis, hCPPObjID))->disp(sub);
};


/*
 * Class:     hpjava_lang_Stride
 * Method:    disp_step
 * Signature: (I)I
 */
//JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_disp_1step
//  (JNIEnv * env, jobject jthis, jint sub_stp)
//{
//  return printf("this function is canceled.\n");
//};

/*
 * Class:     hpjava_lang_Stride
 * Method:    offset
 * Signature: (Lhpjava/lang/Location;)I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_offset
  (JNIEnv *env, jobject jthis, jobject i)
{
  //return(((Map *)env->GetLongField(jthis, hCPPObjID))->offset(*hpjava_lang_Location_ResolvePtr(env,i)));
  return(((Map *)env->GetLongField(jthis, hCPPObjID))->offset(*(LocBlocksIndex *)env->GetLongField(i, hCPPObjID)));
}

/*
 * Class:     hpjava_lang_Stride
 * Method:    step
 * Signature: (Lhpjava/lang/Location;)I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_step
  (JNIEnv * env, jobject jthis, jobject i)
{
  //return(((Map *)env->GetLongField(jthis, hCPPObjID))->step(hpjava_lang_LocBlocksIndex_ResolvePtr(env,i)->sub_stp));
  return(((Map *)env->GetLongField(jthis, hCPPObjID))->step(((LocBlocksIndex *)env->GetLongField(i, hCPPObjID))->sub_stp));
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    updateLocBlk
 * Signature: (Lhpjava/lang/LocBlocksIndex;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_updateLocBlk
  (JNIEnv * env, jobject jthis, jobject jLocBlocksIndex)
{
  //LocBlocksIndex * i = hpjava_lang_LocBlocksIndex_ResolvePtr(env,jLocBlocksIndex);
  LocBlocksIndex * i = (LocBlocksIndex*)env->GetLongField(jLocBlocksIndex, hCPPObjID);
  //Stride * std = hpjava_lang_Stride_ResolvePtr(env, jthis);

  int offset = ((Map *)env->GetLongField(jthis, hCPPObjID))->offset(*i);
  int step = ((Map *)env->GetLongField(jthis, hCPPObjID))->step(i->sub_stp);
  //int len = (Map *)env->GetLongField(jthis, hCPPObjID)->len();

  env->SetIntField(jthis, offsetID, offset);
  env->SetIntField(jthis, stepID, step);
  //env->SetIntField(jthis, lenID, len);
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    show
 * Signature: (Ljava/lang/String;)V
 */
/*
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_show
  (JNIEnv * env, jobject jthis, jstring message)
{
  jclass Map_class=env->FindClass("hpjava/lang/Stride");
  jfieldID sizeID=env->GetFieldID(Map_class, "size", "I");;

  int size=env->GetIntField(jthis, sizeID);

  int length=env->GetStringUTFLength(message);

  char * cmessage=new char[length+1];

  const char * jmessagePtr=env->GetStringUTFChars(message, 0);

  for (int i=0; i<length; i++)
    cmessage[i]=*(jmessagePtr+i);
  cmessage[length]='\0';

  env->ReleaseStringUTFChars(message, jmessagePtr);

  int pos =  env->GetLongField(jthis, hCPPObjID);

  AdlibPrintf("Map %s, Handle %d, Address %x, Size %d\n", cmessage, pos, (Map *)env->GetLongField(jthis, hCPPObjID), size);

  delete [] cmessage;

};
*/
