/*
 * File         : hpjava_spmd_adlib_WriteHalo.C
 * Author       : Guansong Zhang
 * Created      : Thu Jan 22 12:02:26 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/12/07 18:46:24 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "hpjava_spmd_adlib_WriteHalo.h"
#include "adlib.h"

//DAD * hpjava_lang_DAD_ResolvePtr(JNIEnv *, jobject);

extern jfieldID hCPPObjID;
//#include "jctable.h"

//jctable<WriteHalo> hpjava_spmd_adlib_WriteHalo_Table;

/*ResolvePtr
 */
//WriteHalo * hpjava_spmd_adlib_WriteHalo_ResolvePtr(JNIEnv *env, jobject jthis) {
//  return(hpjava_spmd_adlib_WriteHalo_Table.ObjPtr[env->GetLongField(jthis, hCPPObjID)]);
//}

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_init
  (JNIEnv * env, jclass jthis)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");  
  //jctable<WriteHalo> *temphpjava_spmd_adlib_WriteHalo_Table=new jctable<WriteHalo>;
  //hpjava_spmd_adlib_WriteHalo_Table=*temphpjava_spmd_adlib_WriteHalo_Table;
  //delete temphpjava_spmd_adlib_WriteHalo_Table;
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    constructor
 * Signature: (Lhpjava/lang/DAD;I[I[I[I)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_constructor__Lhpjava_lang_DAD_2I_3I_3I_3I
  (JNIEnv * env, jobject jthis, jobject sDAD, jint len, jintArray jwlo, jintArray jwhi, jintArray jmode)
{
  //DAD * sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD); 
  DAD * sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID); 

  jint * wlo=env->GetIntArrayElements(jwlo, 0);
  jint * whi=env->GetIntArrayElements(jwhi, 0);
  jint * mode=env->GetIntArrayElements(jmode, 0);

  // (jint *) != (int *)
  WriteHalo *cppWriteHalo = new WriteHalo(sDADPtr, len, (int *)wlo, (int *)whi, (Mode *)mode);

  env->ReleaseIntArrayElements(jwlo, wlo, JNI_ABORT);
  env->ReleaseIntArrayElements(jwhi, wlo, JNI_ABORT);
  env->ReleaseIntArrayElements(jmode, mode, JNI_ABORT);

  //long pos=hpjava_spmd_adlib_WriteHalo_Table.NewHandle(cppWriteHalo);

  if (cppWriteHalo == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppWriteHalo);  

};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    constructor
 * Signature: (Lhpjava/lang/DAD;I[I[I)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_constructor__Lhpjava_lang_DAD_2I_3I_3I
  (JNIEnv * env, jobject jthis, jobject sDAD, jint len, jintArray jwlo, jintArray jwhi)
{
  //DAD * sDADPtr = hpjava_lang_DAD_ResolvePtr(env, sDAD); 
  DAD * sDADPtr = (DAD*)env->GetLongField(sDAD, hCPPObjID); 

  jint * wlo=env->GetIntArrayElements(jwlo, 0);
  jint * whi=env->GetIntArrayElements(jwhi, 0);

  // (jint *) != (int *)
  WriteHalo *cppWriteHalo = new WriteHalo(sDADPtr, len, (int *)wlo, (int *)whi);

  env->ReleaseIntArrayElements(jwlo, wlo, JNI_ABORT);
  env->ReleaseIntArrayElements(jwhi, wlo, JNI_ABORT);

  //long pos=hpjava_spmd_adlib_WriteHalo_Table.NewHandle(cppWriteHalo);

  if (cppWriteHalo == NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  env->SetLongField(jthis, hCPPObjID, (long)cppWriteHalo);  
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([BJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3BJ
(JNIEnv *env, jobject jthis, jbyteArray src, jlong sOffset)
{
  jbyte * jSA=env->GetByteArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseByteArrayElements(src, jSA, 0);
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([CJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3CJ
(JNIEnv *env, jobject jthis, jcharArray src, jlong sOffset)
{
  jchar * jSA=env->GetCharArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseCharArrayElements(src, jSA, 0);
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([DJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3DJ
(JNIEnv *env, jobject jthis, jdoubleArray src, jlong sOffset)
{
  jdouble * jSA=env->GetDoubleArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseDoubleArrayElements(src, jSA, 0);
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([FJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3FJ
(JNIEnv *env , jobject jthis, jfloatArray src, jlong sOffset)
{
  jfloat * jSA=env->GetFloatArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseFloatArrayElements(src, jSA, 0);
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([IJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3IJ
(JNIEnv *env, jobject jthis, jintArray src, jlong sOffset)
{
  jint * jSA=env->GetIntArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseIntArrayElements(src, jSA, 0);
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([JJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3JJ
(JNIEnv *env, jobject jthis, jlongArray src, jlong sOffset)
{
  jlong * jSA=env->GetLongArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseLongArrayElements(src, jSA, 0);
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([SJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3SJ
(JNIEnv *env, jobject jthis, jshortArray src, jlong sOffset)
{
  jshort * jSA=env->GetShortArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseShortArrayElements(src, jSA, 0);
};

/*
 * Class:     hpjava_spmd_adlib_WriteHalo
 * Method:    execute
 * Signature: ([ZJ)V
 */
JNIEXPORT void JNICALL Java_hpjava_spmd_adlib_WriteHalo_execute___3ZJ
(JNIEnv *env, jobject jthis, jbooleanArray src, jlong sOffset)
{
  jboolean * jSA=env->GetBooleanArrayElements(src, 0);

  //hpjava_spmd_adlib_WriteHalo_ResolvePtr(env, jthis)->execute(jSA+sOffset); 
  ((WriteHalo*)env->GetLongField(jthis, hCPPObjID))->execute(jSA+sOffset); 

  env->ReleaseBooleanArrayElements(src, jSA, 0);
};
