/*
 * File         : Adlib.java
 * Author       : Guansong Zhang, Han-Ku Lee
 * Created      : Tue Nov  4 20:40:55 1997
 * Revision     : $Revision: 1.8 $
 * Updated      : $Date: 1999/12/21 01:37:54 $
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Adlib extends InterfaceObject {

  static public native void _Initialize(String[] args);
  static public native void _Finalize();
  static public native void _InitInterFace();  
  static public native void _InitAPG(Group apg);

  static public void remap(SectionI dst, SectionI src) {

    //dst.dad.show("dst"); //debug
    //src.dad.show("src"); //debug

    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };

  static public void remap(SectionF dst, SectionF src) {
    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };
  
  static public void remap(SectionB dst, SectionB src) {
    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };
  
  static public void remap(SectionC dst, SectionC src) {
    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };
  
  static public void remap(SectionD dst, SectionD src) {
    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };
  
  static public void remap(SectionJ dst, SectionJ src) {
    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };
  
  static public void remap(SectionS dst, SectionS src) {
    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };
  
  static public void remap(SectionZ dst, SectionZ src) {
    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };
  
  static public void shift(SectionI dst, SectionI src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionF dst, SectionF src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionB dst, SectionB src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionC dst, SectionC src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionD dst, SectionD src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionJ dst, SectionJ src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionS dst, SectionS src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionZ dst, SectionZ src, int shift, int dim, int mode) {
    Shift schedule = new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };
		
  static public double maxval(SectionD src){
    Maxval schedule = new Maxval(src);
    return schedule.doubleExecute();
  };
		
  static public float maxval(SectionF src){
    Maxval schedule = new Maxval(src);
    return schedule.floatExecute();
  };
		
  static public int maxval(SectionI src){
    Maxval schedule = new Maxval(src);
    return schedule.intExecute();
  };
		
  static public long maxval(SectionJ src){
    Maxval schedule = new Maxval(src);
    return schedule.longExecute();
  };
		
  static public short maxval(SectionS src){
    Maxval schedule = new Maxval(src);
    return schedule.shortExecute();
  };

  static public double minval(SectionD src){
    Minval schedule = new Minval(src);
    return schedule.doubleExecute();
  };
		
  static public float minval(SectionF src){
    Minval schedule = new Minval(src);
    return schedule.floatExecute();
  };
		
  static public int minval(SectionI src){
    Minval schedule = new Minval(src);
    return schedule.intExecute();
  };
		
  static public long minval(SectionJ src){
    Minval schedule = new Minval(src);
    return schedule.longExecute();
  };
		
  static public short minval(SectionS src){
    Minval schedule = new Minval(src);
    return schedule.shortExecute();
  };

  static public float dotProduct(SectionF src1, SectionF src2){
    DotProduct schedule = new DotProduct(src1, src2);
    return schedule.floatExecute();
  }

  static public void copy(SectionI dst, SectionI src) {
    // This is temporaryly implemented as remap;

    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };

  static public void copy(SectionF dst, SectionF src) {
    // This is temporaryly implemented as remap;

    Remap schedule = new Remap(dst, src);
    schedule.execute();
  };

  static public void writeHalo(SectionB src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionC src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionD src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionF src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionI src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionJ src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionS src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionZ src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionB src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionC src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionD src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionF src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionI src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionJ src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionS src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionZ src, int[] wlo, int[] whi) {
    WriteHalo schedule = new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public native void _aprintf(String control, DAD dad, int type, Object ref, int ost);

  static public void aprintf(String control, Section arg) {
    if (arg instanceof SectionI) {
      _aprintf(control, arg.dad(), TypeConstants.INT, arg.ref(), arg.off());
    }
    else if (arg instanceof SectionF) {
      _aprintf(control, arg.dad(), TypeConstants.FLOAT, arg.ref(), arg.off());
    }
    else
      throw new Error();
  };

  //using java buffer is different from C buffer
  //so a native method is added.

  static private native void printString(String s);

  static public void rprint(String x) {
    Procs0 root = new Procs0();
    if (root.on()) {
      printString(x+"");
    } root.no();
  }

  static public void rprintln(String x) {
    Procs0 root = new Procs0();
    if (root.on()) {
      printString(x+"\n");
    } root.no();
  }
  
//   static public void Initialize(String[] args) {
//     Spmd.Initialize(args);
//   };

//   static public void Finalize() {
//     Spmd.Finalize();
//   };
  
//   static public Group apg;
//   static public Group global;
//   static public Group root;

}
