/*
 * File         : DotProduct.java
 * Author       : Han-Ku Lee
 * Created      : Wed Oct 27 20:51:40 1999
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/12/20 22:21:43 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1999
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class DotProduct extends InterfaceObject {
  
  private static native void init();

  public native void finalize();
  static public native void clean();

  private native void float_constructor(DAD src1, DAD src2, int len); 
  
  public DotProduct(SectionF src1, SectionF src2) {

    sref1 = src1.dat();
    soff1 = src1.off();

    sref2 = src2.dat();
    soff2 = src2.off();
    
    float_constructor(src1.dad(), src2.dad(), TypeConstants.FLOATSIZE);
  }
					
  //private native SectionF execute(float[] src1, float[] src2);
  private native float execute(float[] src1, float[] src2);
  
  public float floatExecute(){
    return execute((float[])sref1, (float[])sref2);
  }
	
  private int type;
  private Object sref1;
  private Object sref2;
  private int soff1;
  private int soff2;

  static {
    init();
  }

}
