/*
 * File         : Gather.java
 * Author       : Qiang Zheng
 * Created      : Dec 27 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/12/07 18:52:23 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Gather extends InterfaceObject {
  
  private static native void init();
  public static native void clean();

  private native void constructor(DAD dst, DAD src, int len
	,DAD[] s, int[][] sd, DAD msk, int[] mskd); 

  /* class Gather {
   public :
   Gather(const DAD* loc, const DAD* rem, const int len,
         const DAD** subs, const int** subsData,
         const DAD* msk, const int* mskData) :
      skeleton(loc, rem, len, subs, subsData, msk, mskData), bcst(loc, len) {}

   void execute(void* locDat, void* remDat) {
     skeleton.gather(locDat, remDat) ;
     bcst.execute(locDat) ;
   }
   private :
     GatherSkeleton skeleton ;
     Replicate bcst ;
   }; */

  /* public Gather(SectionI dst, SectionI src, SectionI subs_0) {
    type=TypeConstants.INT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[1];
	subsDad[0] = subs_0.dad();
	
	DAD subsDat[] = new int[1];
	subsDat[0] = subs_0.dat();
	
	constructor(dst.dad(), src.dad(), TypeConstants.INTSIZE
		, subsDad, subsDat, 0,0);
  }

  public Gather(SectionF dst, SectionF src, SectionI subs_0) {
    type=TypeConstants.FLOAT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[1];
	subsDad[0] = subs_0.dad();
	
	DAD subsDat[] = new int[1];
	subsDat[0] = subs_0.dat();
	
	constructor(dst.dad(), src.dad(), TypeConstants.FLOATSIZE
		, subsDad, subsDat, 0,0);
  }

  public Gather(SectionI dst, SectionI src
    , SectionI subs_0, SectionI subs_1) {

    type=TypeConstants.INT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[2];
	subsDad[0] = subs_0.dad();
	subsDad[1] = subs_1.dad();
	
	DAD subsDat[] = new int[2];
	subsDat[0] = subs_0.dat();
	subsDat[1] = subs_1.dat();
	
	constructor(dst.dad(), src.dad(), TypeConstants.INTSIZE
		, subsDad, subsDat, 0,0);
  }

  public Gather(SectionF dst, SectionF src
    , SectionI subs_0, SectionI subs_1) {

    type=TypeConstants.FLOAT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[2];
	subsDad[0] = subs_0.dad();
	subsDad[1] = subs_1.dad();
	
	DAD subsDat[] = new int[2];
	subsDat[0] = subs_0.dat();
	subsDat[1] = subs_1.dat();
	
	constructor(dst.dad(), src.dad(), TypeConstants.FLOATSIZE
		, subsDad, subsDat, 0,0);
  }

  public Gather(SectionI dst, SectionI src
    , SectionI subs_0, SectionI msk) {

    type=TypeConstants.INT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[1];
	subsDad[0] = subs_0.dad();
	
	DAD subsDat[] = new int[1];
	subsDat[0] = subs_0.dat();

	constructor(dst.dad(), src.dad(), TypeConstants.INTSIZE
      , subsDad, subsDat, msk.dad(), msk.dat());
  }

  public Gather(SectionF dst, SectionF src, SectionI subs_0, SectionI msk) {
    type=TypeConstants.FLOAT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[1];
	subsDad[0] = subs_0.dad();
	
	DAD subsDat[] = new int[1];
	subsDat[0] = subs_0.dat();

	constructor(dst.dad(), src.dad(), TypeConstants.FLOATSIZE
      , subsDad, subsDat, msk.dad(), msk.dat());
  } */

  public Gather(SectionI dst, SectionI src
	, SectionI subs_0, SectionI subs_1, SectionI msk) {
    type=TypeConstants.INT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[2];
	subsDad[0] = subs_0.dad();
	subsDad[1] = subs_1.dad();
	
	int subsDat[][] = new int[2][];
	subsDat[0] = new int[subs_0.dat().length];	
	subsDat[1] = new int[subs_1.dat().length];	

	for(int i = 0; i < subs_0.dat().length; i++)
      subsDat[0][i] = subs_0.dat()[i];

	for(int i = 0; i < subs_0.dat().length; i++)
      subsDat[1][i] = subs_1.dat()[i];

	constructor(dst.dad(), src.dad(), TypeConstants.INTSIZE
      , subsDad, subsDat, msk.dad(), msk.dat());
  }

  public Gather(SectionF dst, SectionF src
	, SectionI subs_0, SectionI subs_1, SectionI msk) {
    type=TypeConstants.FLOAT;
    sref=src.dat();
    dref=dst.dat();

    soff=src.off();
    doff=dst.off();

	DAD subsDad[] = new DAD[2];
	subsDad[0] = subs_0.dad();
	subsDad[1] = subs_1.dad();
	
	int subsDat[][] = new int[2][];
	subsDat[0] = new int[subs_0.dat().length - 1];	
	subsDat[1] = new int[subs_1.dat().length - 1];	

	for(int i = 0; i < subs_0.dat().length; i++)
      subsDat[0][i] = subs_0.dat()[i];

	for(int i = 0; i < subs_0.dat().length; i++)
      subsDat[1][i] = subs_1.dat()[i];

	constructor(dst.dad(), src.dad(), TypeConstants.FLOATSIZE
      , subsDad, subsDat, msk.dad(), msk.dat());
  }

  public native void finalize();

  private native void execute(boolean[] dst, long doffset, boolean[] src, long soffset);
  private native void execute(byte[] dst, long doffset, byte[] src, long soffset);
  private native void execute(char[] dst, long doffset, char[] src, long soffset);
  private native void execute(short[] dst, long doffset, short[] src, long soffset);
  private native void execute(int[] dst, long doffset, int[] src, long soffset);
  private native void execute(long[] dst, long doffset, long[] src, long soffset);
  private native void execute(float[] dst, long doffset, float[] src, long soffset);
  private native void execute(double[] dst, long doffset, double[] src, long soffset);

  public void execute() {
    
    switch (this.type) {

    case TypeConstants.INT: {
      execute((int[])dref, doff, (int[])sref, soff); 
      break;
    }

    case TypeConstants.FLOAT: {
      execute((float[])dref, doff, (float[])sref, soff); 
      break;
    }

    default:
      throw new Error("not finished");
    }

  };

  private int type;
  private Object sref, dref;
  private int soff, doff;

  static {
    init();
  }

}
