/*
 * File         : Minval.java
 * Author       : Han-Ku Lee
 * Created      : Wed Nov 10 19:23:40 1999
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/12/07 18:52:25 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1999
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Minval extends InterfaceObject {
  
  private static native void init();

  public native void finalize();
  static public native void clean();

  private native void double_constructor(DAD src, int len); 
  private native void float_constructor(DAD src, int len); 
  private native void int_constructor(DAD src, int len); 
  private native void long_constructor(DAD src, int len); 
  private native void short_constructor(DAD src, int len); 
  
  public Minval(SectionI src) {
    type = TypeConstants.INT;

    sref = src.dat();
    soff = src.off();
    
    int_constructor(src.dad(), TypeConstants.INTSIZE);
  }
  
  public Minval(SectionF src) {
    type = TypeConstants.FLOAT;

    sref = src.dat();
    soff = src.off();
    
    float_constructor(src.dad(), TypeConstants.FLOATSIZE);
  }
			
  public Minval(SectionD src) {
    type = TypeConstants.DOUBLE;

    sref = src.dat();
    soff = src.off();
    
    double_constructor(src.dad(), TypeConstants.DOUBLESIZE);
  }
		
  public Minval(SectionS src) {
    type = TypeConstants.SHORT;

    sref = src.dat();
		soff = src.off();
    
    short_constructor(src.dad(), TypeConstants.SHORTSIZE);
  }
		
  public Minval(SectionJ src) {
    type = TypeConstants.LONG;

    sref = src.dat();
    soff = src.off();
    
    long_constructor(src.dad(), TypeConstants.LONGSIZE);
  }
		
  private native int execute(int[] src);
  private native float execute(float[] src);
  private native short execute(short[] src);
	private native long execute(long[] src);
  private native double execute(double[] src);
  
  public int intExecute(){    
    return execute((int[])sref);
  }
  
  public float floatExecute(){
    return execute((float[])sref);
  }
	
  public short shortExecute(){
    return execute((short[])sref);
  }

  public long longExecute(){
    return execute((long[])sref);
  }
		
  public double doubleExecute(){
    return execute((double[])sref);
  }
		
  private int type;
  private Object sref;
  private int soff;

  static {
    init();
  }

}
