/*
 * File         : Remap.java
 * Author       : Guansong Zhang
 * Created      : Mon Oct 27 16:18:24 1997
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1999/12/07 18:51:36 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Remap extends InterfaceObject {
  
  private static native void init();
  public static native void clean();

  private native void constructor(DAD dst, DAD src, int len); 

  /*
  public Remap(DAD dst, DAD src, int _type) {
    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6:
      len=4;
      constructor(dst, src, len);
      break;
    default:
      System.out.println("not finished");

    };
  };

  */

  public Remap(SectionB dst, SectionB src) {
    type=TypeConstants.BYTE;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.BYTESIZE);
  }

  public Remap(SectionC dst, SectionC src) {
    type=TypeConstants.CHAR;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.CHARSIZE);
  }

  public Remap(SectionD dst, SectionD src) {
    type=TypeConstants.DOUBLE;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.DOUBLESIZE);
  }

  public Remap(SectionF dst, SectionF src) {
    type=TypeConstants.FLOAT;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.FLOATSIZE);
  }

  public Remap(SectionI dst, SectionI src) {
    type=TypeConstants.INT;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.INTSIZE);
  }

  public Remap(SectionJ dst, SectionJ src) {
    type=TypeConstants.LONG;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.LONGSIZE);
  }

  public Remap(SectionS dst, SectionS src) {
    type=TypeConstants.SHORT;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.SHORTSIZE);
  }

  public Remap(SectionZ dst, SectionZ src) {
    type=TypeConstants.BOOLEAN;
    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.BOOLEANSIZE);
  }

  public native void finalize();

  private native void execute(boolean[] dst, long dOffset, boolean[] src, long sOffset);
  private native void execute(byte[] dst, long dOffset, byte[] src, long sOffset);
  private native void execute(char[] dst, long dOffset, char[] src, long sOffset);
  private native void execute(short[] dst, long dOffset, short[] src, long sOffset);
  private native void execute(int[] dst, long dOffset, int[] src, long sOffset);
  private native void execute(long[] dst, long dOffset, long[] src, long sOffset);
  private native void execute(float[] dst, long dOffset, float[] src, long sOffset);
  private native void execute(double[] dst, long dOffset, double[] src, long sOffset);

  public void execute() {
    
    switch (this.type) {
    case TypeConstants.INT: {
      execute((int[])dref, doff, (int[])sref, soff); 
      break;
    }
    case TypeConstants.FLOAT: {
      execute((float[])dref, doff, (float[])sref, soff); 
      break;
    }
    case TypeConstants.BYTE: {
      execute((byte[])dref, doff, (byte[])sref, soff); 
      break;
    }
    case TypeConstants.CHAR: {
      execute((char[])dref, doff, (char[])sref, soff); 
      break;
    }
    case TypeConstants.LONG: {
      execute((long[])dref, doff, (long[])sref, soff); 
      break;
    }
    case TypeConstants.DOUBLE: {
      execute((double[])dref, doff, (double[])sref, soff); 
      break;
    }
    case TypeConstants.SHORT: {
      execute((short[])dref, doff, (short[])sref, soff); 
      break;
    }
    case TypeConstants.BOOLEAN: {
      execute((boolean[])dref, doff, (boolean[])sref, soff); 
      break;
    }

    default:
      throw new Error("Not defined type ...");
    }

  };

  private int type;
  private Object sref, dref;
  private int soff, doff;

  static {
    init();
  }

}
