/*
 * File         : Shift.java
 * Author       : Guansong Zhang, Han-Ku Lee
 * Created      : Tue Nov  4 20:40:55 1997
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1999/12/07 18:51:37 $
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Shift extends InterfaceObject {
  
  private static native void init();
  public static native void clean();

  private native void constructor(DAD dst, DAD src, int len, int shift, int dim, int mode); 

  /*
  public Shift(DAD dst, DAD src, int _type, int shift, int dim, int mode) {
    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6: 
      len=4;
      constructor(dst, src, len, shift, dim, mode);
      break;
    default:
      System.out.println("not finished");

    };
  };

  */

  public Shift(SectionI dst, SectionI src, int shift, int dim, int mode) {
    type=TypeConstants.INT;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.INTSIZE, shift, dim, mode);
  }

  public Shift(SectionF dst, SectionF src, int shift, int dim, int mode) {
    type=TypeConstants.FLOAT;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.FLOATSIZE, shift, dim, mode);
  }

  public Shift(SectionB dst, SectionB src, int shift, int dim, int mode) {
    type=TypeConstants.BYTE;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.BYTESIZE, shift, dim, mode);
  }

  public Shift(SectionC dst, SectionC src, int shift, int dim, int mode) {
    type=TypeConstants.CHAR;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.CHARSIZE, shift, dim, mode);
  }

  public Shift(SectionD dst, SectionD src, int shift, int dim, int mode) {
    type=TypeConstants.DOUBLE;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.DOUBLESIZE, shift, dim, mode);
  }

  public Shift(SectionS dst, SectionS src, int shift, int dim, int mode) {
    type=TypeConstants.SHORT;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.SHORTSIZE, shift, dim, mode);
  }

  public Shift(SectionJ dst, SectionJ src, int shift, int dim, int mode) {
    type=TypeConstants.LONG;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.LONGSIZE, shift, dim, mode);
  }

  public Shift(SectionZ dst, SectionZ src, int shift, int dim, int mode) {
    type=TypeConstants.BOOLEAN;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.BOOLEANSIZE, shift, dim, mode);
  }

  public native void finalize();

  private native void execute(int[] dst, long dOffset, int[] src, long sOffset);
  private native void execute(float[] dst, long dOffset, float[] src, long sOffset);
  private native void execute(char[] dst, long dOffset, char[] src, long sOffset);
  private native void execute(short[] dst, long dOffset, short[] src, long sOffset);
  private native void execute(long[] dst, long dOffset, long[] src, long sOffset);
  private native void execute(double[] dst, long dOffset, double[] src, long sOffset);
  private native void execute(byte[] dst, long dOffset, byte[] src, long sOffset);
  private native void execute(boolean[] dst, long dOffset, boolean[] src, long sOffset);
   
  public void execute() {
    
    switch (this.type) {
    case TypeConstants.INT: {
      execute((int[])dref, doff, (int[])sref, soff); 
      break;
    }
    case TypeConstants.FLOAT: {
      execute((float[])dref, doff, (float[])sref, soff); 
      break;
    }
    case TypeConstants.CHAR: {
      execute((char[])dref, doff, (char[])sref, soff); 
      break;
    }
    case TypeConstants.SHORT: {
      execute((short[])dref, doff, (short[])sref, soff); 
      break;
    }
    case TypeConstants.LONG: {
      execute((long[])dref, doff, (long[])sref, soff); 
      break;
    }
    case TypeConstants.DOUBLE: {
      execute((double[])dref, doff, (double[])sref, soff); 
      break;
    }
    case TypeConstants.BYTE: {
      execute((byte[])dref, doff, (byte[])sref, soff); 
      break;
    }
    case TypeConstants.BOOLEAN: {
      execute((boolean[])dref, doff, (boolean[])sref, soff); 
      break;
    }
    default:
      System.out.println("No Such a case ...");
      break;
    }

  };

  private int type;
  private Object sref, dref;
  private int soff, doff;

  static {
    init();
  }

}
