/*
 * File         : WriteHalo.java
 * Author       : Guansong Zhang
 * Created      : Thu Jan 22 10:48:19 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1999/12/07 18:51:37 $
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class WriteHalo extends InterfaceObject {

  private static native void init();
  public static native void clean();

  private native void constructor(DAD src, int len, int[] wlo, int[] whi, int[] mode);
  private native void constructor(DAD src, int len, int[] wlo, int[] whi);

  /*
  public WriteHalo(DAD src, int _type, int[] wlo, int[] whi, int[] mode) {
    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6:
      len=4;
      constructor(src, len, wlo, whi, mode);
      break;
    default:
      System.out.println("not finished");
    }
  }

  public WriteHalo(DAD src, int _type, int[] wlo, int[] whi) {

    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6:
      len=4;
      constructor(src, len, wlo, whi);
      break;
    default:
      System.out.println("not finished");
    }
  }
  */

  public WriteHalo(SectionI src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.INT;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.INTSIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionF src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.FLOAT;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.FLOATSIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionB src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.BYTE;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.BYTESIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionC src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.CHAR;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.CHARSIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionD src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.DOUBLE;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.DOUBLESIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionJ src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.LONG;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.LONGSIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionS src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.SHORT;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.SHORTSIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionZ src, int[] wlo, int[] whi, int[] mode) {
    type=TypeConstants.BOOLEAN;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.BOOLEANSIZE, wlo, whi, mode);    
  }  

  public WriteHalo(SectionI src, int[] wlo, int[] whi) {
    type=TypeConstants.INT;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.INTSIZE, wlo, whi);    
  }    

  public WriteHalo(SectionF src, int[] wlo, int[] whi) {
    type=TypeConstants.FLOAT;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.FLOATSIZE, wlo, whi);    
  }    

  public WriteHalo(SectionB src, int[] wlo, int[] whi) {
    type=TypeConstants.BYTE;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.BYTESIZE, wlo, whi);    
  }  

  public WriteHalo(SectionC src, int[] wlo, int[] whi) {
    type=TypeConstants.CHAR;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.CHARSIZE, wlo, whi);    
  }  

  public WriteHalo(SectionD src, int[] wlo, int[] whi) {
    type=TypeConstants.DOUBLE;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.DOUBLESIZE, wlo, whi);    
  }  

  public WriteHalo(SectionJ src, int[] wlo, int[] whi) {
    type=TypeConstants.LONG;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.LONGSIZE, wlo, whi);    
  }  

  public WriteHalo(SectionS src, int[] wlo, int[] whi) {
    type=TypeConstants.SHORT;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.SHORTSIZE, wlo, whi);    
  }  

  public WriteHalo(SectionZ src, int[] wlo, int[] whi) {
    type=TypeConstants.BOOLEAN;

    sref=src.dat();
    soff=src.off();

    constructor(src.dad(), TypeConstants.BOOLEANSIZE, wlo, whi);    
  }  

  private native void execute(boolean[] src, long sOffset);
  private native void execute(byte[] src, long sOffset);
  private native void execute(char[] src, long sOffset);
  private native void execute(short[] src, long sOffset);
  private native void execute(int[] src, long sOffset);
  private native void execute(long[] src, long sOffset);
  private native void execute(float[] src, long sOffset);
  private native void execute(double[] src, long sOffset);

  public void execute() {

    switch (this.type) {

    case TypeConstants.INT: {
      execute((int[])sref, soff); 
      break;
    }
    case TypeConstants.FLOAT: {
      execute((float[])sref, soff); 
      break;
    }
    case TypeConstants.BYTE: {
      execute((byte[])sref, soff); 
      break;
    }
    case TypeConstants.CHAR: {
      execute((char[])sref, soff); 
      break;
    }
    case TypeConstants.DOUBLE: {
      execute((double[])sref, soff); 
      break;
    }
    case TypeConstants.LONG: {
      execute((long[])sref, soff); 
      break;
    }
    case TypeConstants.SHORT: {
      execute((short[])sref, soff); 
      break;
    }
    case TypeConstants.BOOLEAN: {
      execute((boolean[])sref, soff); 
      break;
    }

    default:
      System.out.println("Not defined type");
      break;
    }
  }

  private int type;
  private Object sref;
  private int soff;

  static {
    init();
  }

}
